/** Logging routines that depend on jansson.
 *
 * @file
 * @author Steffen Vogel <stvogel@eonerc.rwth-aachen.de>
 * @copyright 2017-2018, Institute for Automation of Complex Power Systems, EONERC
 * @license GNU General Public License (version 3)
 *
 * VILLASnode
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *********************************************************************************/

#pragma once

struct log;

#include <jansson.h>

#include <villas/log.h>

#ifdef __cplusplus
extern "C" {
#endif

/** Wrapper for log_parse, to check if config file exists **/
int log_parse_wrapper(struct log *l, json_t *cfg);

/** Parse logging configuration. */
int log_parse(struct log *l, json_t *cfg);

/** Print configuration error and exit. */
void jerror(json_error_t *err, const char *fmt, ...)
	__attribute__ ((format(printf, 2, 3)));


#ifdef __cplusplus
}
#endif
